local Capping = Capping
local self = Capping
local L = CappingLocale
CappingLocale = nil  -- remove global reference

local pname
local strmatch, strlower, pairs, format, tonumber = strmatch, strlower, pairs, format, tonumber
local UnitIsEnemy, UnitName, GetTime, SendAddonMessage = UnitIsEnemy, UnitName, GetTime, SendAddonMessage
local assaulted, claimed, defended, taken = L["has assaulted"], L["claims the"], L["has defended the"], L["has taken the"]

------------------------------------------------ Arathi Basin -----------------------------------------------------
--------------------------
function Capping:StartAB()
--------------------------
	self:SetupAssault(62)
	self:NewEstimator(1)
end


------------------------------------------------ Alterac Valley ---------------------------------------------------
--------------------------
function Capping:StartAV()
--------------------------
	if not self.AVAssaults then
		pname = pname or UnitName("player")
		---------------------------
		function Capping:AVQuests()
		---------------------------
			if not self.db.avquest then return end
			local event = event
			local target = UnitName("target")
			if event=="GOSSIP_SHOW" or event=="QUEST_PROGRESS" then
				if target == L["Smith Regzar"] or target == L["Murgot Deepforge"] then
					-- Open Quest to Smith or Murgot
					if GetGossipOptions() and strmatch(GetGossipOptions(), L["Upgrade to"] ) then
						SelectGossipOption(1)
					elseif GetItemCount(17422) >= 20 then -- Armor Scraps 17422
						SelectGossipAvailableQuest(1)
					end
				elseif target == L["Primalist Thurloga"] then
					local num = GetItemCount(17306) -- Stormpike Soldier's Blood 17306
					if num >= 5 then
						SelectGossipAvailableQuest(2)
					elseif num > 0 then
						SelectGossipAvailableQuest(1)
					end
				elseif target == L["Arch Druid Renferal"] then
					local num = GetItemCount(17423) -- Storm Crystal 17423
					if num >= 5 then
						SelectGossipAvailableQuest(2)
					elseif num > 0 then
						SelectGossipAvailableQuest(1)
					end
				elseif target == L["Stormpike Ram Rider Commander"] then
					if GetItemCount(17643) > 0 then -- Frost Wolf Hide 17643
						SelectGossipAvailableQuest(1)
					end
				elseif target == L["Frostwolf Wolf Rider Commander"] then
					if GetItemCount(17642) > 0 then -- Alterac Ram Hide 17642
						SelectGossipAvailableQuest(1)
					end
				end
			end
			if event == "QUEST_PROGRESS" then
				if IsQuestCompletable() then
					CompleteQuest()
				end
			elseif event == "QUEST_COMPLETE" then
				GetQuestReward(0)
			end
		end

		------------------------------------------------------
		function Capping:AVSync(prefix, message, chan, sender)
		------------------------------------------------------
			if prefix ~= "cap" or sender == pname then return end
			if message == "r" then
				for value, color in pairs(Capping.activebars) do
					local f = Capping:GetBar(value)
					if f and f:IsShown() then
						SendAddonMessage("cap", format("%s@%d@%d@%s", value, f.duration, f.duration - f.remaining, color), "WHISPER", sender)
					end
				end
			else
				local name, duration, elapsed, color = strmatch(message, "^(.+)@(%d+)@(%d+)@(%a+)$")
				local f = self:GetBar(name)
				if name and elapsed and (not f or not f:IsShown()) then
					local icon
					if name == L["Ivus begins moving"] then
						icon = "Interface\\Icons\\Spell_Nature_NaturesBlessing"
					elseif name == L["Lokholar begins moving"] then
						icon = "Interface\\Icons\\Spell_Frost_Glacier"
					else
						icon = self:GetIconData(color, strmatch(self:GetNodeTable()[name], "(%a+)__"))
					end
					duration = tonumber(duration)
					self:StartBar(name, duration, duration - tonumber(elapsed), icon, color or "info2")
				end
			end
		end
		-------------------------
		function Capping:SyncAV()
		-------------------------
			SendAddonMessage("cap", "r", "BATTLEGROUND")
		end
	end
	
	self:SetupAssault(245)
	self:RegisterTempEvent("GOSSIP_SHOW", "AVQuests")
	self:RegisterTempEvent("QUEST_PROGRESS", "AVQuests")
	self:RegisterTempEvent("QUEST_COMPLETE", "AVQuests")

	self:RegisterTempEvent("CHAT_MSG_ADDON", "AVSync")
	self:SyncAV()
end


------------------------------------------------ Eye of the Storm -------------------------------------------------
local ef, ResetCarrier
----------------------------
function Capping:StartEotS()
----------------------------
	if not ef then
		local eficon, eftext, carrier, cclass
		-- handles secure stuff
		local function SetEotSCarrierAttribute()
			ef:SetAlpha(1)
			ef:SetFrameStrata("HIGH")
			ef:SetPoint("LEFT", UIParent, "BOTTOMLEFT", AlwaysUpFrame1:GetRight() - 14, AlwaysUpFrame1:GetBottom() + 8.5)
			ef:SetAttribute("macrotext", format("/target %s", carrier or ""))
		end
		-- resets carrier display
		ResetCarrier = function(captured)
			carrier, ef.faction, ef.car = nil, nil, nil
			eftext:SetText("")
			eficon:Hide()
			if captured then
				self:StartBar(L["Flag respawns"], 9, 9, self:GetIconData(strlower(UnitFactionGroup("player")), "flag"), "info2")
			end
			self:CheckCombat(SetEotSCarrierAttribute)
		end
		local function CarrierOnClick(this)
			if IsControlKeyDown() and carrier then
				SendChatMessage(format(L["%s's flag carrier: %s (%s)"], this.faction, carrier, cclass), "BATTLEGROUND")
			end
		end
		-- parse battleground messages
		local function EotSFlag(a1, faction)
			local name = strmatch(a1, L["^(.+) has taken the flag!"])
			if name then
				if name == "L'Alliance" then  -- frFR
					ResetCarrier(true)
				else
					cclass = self:GetClassByName(name, faction)
					carrier, ef.car = name, true
					ef.faction = (faction == 0 and _G.FACTION_HORDE) or _G.FACTION_ALLIANCE
					ef:SetAlpha(0.6)
					eftext:SetFormattedText("|cff%s%s|r", self:GetClassColorHex(cclass), carrier or "")
					eficon:SetTexture((faction == 0 and "Interface\\WorldStateFrame\\HordeFlag") or "Interface\\WorldStateFrame\\AllianceFlag")
					eficon:Show()
					self:CheckCombat(SetEotSCarrierAttribute)
				end
			elseif strmatch(a1, L["dropped"]) then
				ResetCarrier()
			elseif strmatch(a1, L["captured the"]) or strmatch(a1, taken) then
				ResetCarrier(true)
			end
		end
		--------------------------------
		function Capping:HFlagUpdate(a1)
		--------------------------------
			EotSFlag(a1, 0)
		end
		--------------------------------
		function Capping:AFlagUpdate(a1)
		--------------------------------
			EotSFlag(a1, 1)
		end
		
		ef = self:CreateCarrierButton("CappingEotSFrame", 132, 18, CarrierOnClick)
		eficon = ef:CreateTexture(nil, "ARTWORK")  -- flag icon
		eficon:SetPoint("TOPLEFT", ef, "TOPLEFT", 0, 1)
		eficon:SetPoint("BOTTOMRIGHT", ef, "BOTTOMLEFT", 20, -1)

		eftext = self:CreateText(ef, 13, "LEFT", eficon, 22, 0, ef, 0, 0)  -- carrier text
		ef.text = eftext

		self:AddFrameToHide(ef)  -- add to the tohide list to hide when bg is over
	end
	
	ef:Show()
	ResetCarrier()
	
	-- setup for final score estimation (2 for EotS)
	self:NewEstimator(2)
	self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_HORDE", "HFlagUpdate")
	self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE", "AFlagUpdate")
end


------------------------------------------------ Isle of Conquest --------------------------------------
---------------------------
function Capping:StartIoC()
---------------------------
	if not self.HIoCAssault then
		pname = pname or UnitName("player")
		local siege = GetSpellInfo(56661)
		local damaged, _, siegeicon = GetSpellInfo(67323)
		local nodes = { L["Alliance Keep"], L["Horde Keep"], }
		local function IoCAssault(text, faction)
			text = strlower(text)
			for _, value in ipairs(nodes) do
				if strmatch(text, strlower(value)) then
					if strmatch(text, assaulted) then
						return self:StartBar(value, 62, 62, self:GetIconData(faction, "tower"), faction)
					elseif strmatch(text, defended) or strmatch(text, taken) or strmatch(text, claimed) then
						return self:StopBar(value)
					end
				end
			end
		end
		--------------------------------
		function Capping:HIoCAssault(a1)
		--------------------------------
			IoCAssault(a1, "horde")
		end
		--------------------------------
		function Capping:AIoCAssault(a1)
		--------------------------------
			IoCAssault(a1, "alliance")
		end
		-------------------------------------------------------
		function Capping:IoCSync(prefix, message, chan, sender)  -- only sync for siege engine timer
		-------------------------------------------------------
			if (prefix ~= "cap" and prefix ~= "Cap") or sender == pname then return end
			local f = self:GetBar(siege)
			if (not f or not f:IsShown()) and message then
				local faction, remain = strmatch(message, "(%a)(%d+)")
				faction = (faction == "a" and "alliance") or (faction == "h" and "horde")
				remain = (remain == "1" and 183) or (remain == "2" and 92) or tonumber(remain or 0) or 0
				if faction and remain > 0 then
					self:StartBar(siege, 183, remain, siegeicon, faction)
				end
			end
		end
		------------------------------------
		function Capping:SiegeEngine(a1, a2)
		------------------------------------
			if a1 and a2 then
				if strmatch(a1, L["seaforium bombs"]) or strmatch(a1, L["It's broken"]) then
					local faction = (strmatch(a2, L["Goblin"]) and "horde") or "alliance"
					self:StartBar(siege, 183, 183, siegeicon, faction)
					SendAddonMessage("cap", faction == "alliance" and "a1" or "h1", "BATTLEGROUND")
				elseif strmatch(a1, L["halfway"]) then
					local faction = (strmatch(a2, L["Goblin"]) and "horde") or "alliance"
					self:StartBar(siege, 183, 92, siegeicon, faction)
					SendAddonMessage("cap", faction == "alliance" and "a2" or "h2", "BATTLEGROUND")
				end
			else  -- check target
				local name, _, icon, _, _, duration, endtime = UnitBuff("target", 1)
				if name == damaged and endtime then
					local remain, faction = endtime - GetTime(), strlower(UnitFactionGroup("target"))
					if remain < 5 then return end
					self:StartBar(siege, 183, remain, siegeicon, faction)
					SendAddonMessage("Cap", format("%s%d", strsub(faction, 1, 1), remain), "BATTLEGROUND")
				end
			end
		end
	end
	self:SetupAssault(62, true)
	self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_HORDE", "HIoCAssault")
	self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE", "AIoCAssault")
	self:RegisterTempEvent("CHAT_MSG_MONSTER_YELL", "SiegeEngine")
	self:RegisterTempEvent("PLAYER_TARGET_CHANGED", "SiegeEngine")
	self:RegisterTempEvent("CHAT_MSG_ADDON", "IoCSync")
end


------------------------------------------------ Warsong Gulch ----------------------------------------------------
---------------------------
function Capping:StartWSG()
---------------------------
	if not self.WSGBulk then  -- init some data and create carrier frames
		local wsgicon, playerfaction, prevtime
		local af, aftext, aftexthp, acarrier, aclass
		local hf, hftext, hftexthp, hcarrier, hclass
		local ahealth, hhealth = 0, 0
		local elap, found, synctime = 0, 0, 0
		local unknownhp = "|cff777777??%|r"
		pname = pname or UnitName("player")
		
		-- props to "Fedos" and the ICU mod
		-- updates a carrier's frame secure stuff, button will be slightly transparent if button cannot update (in combat)
		local function SetWSGCarrierAttribute()
			af:SetAlpha(1)
			af:SetAttribute("macrotext", format("/target %s", acarrier or ""))
			af:SetPoint("LEFT", UIParent, "BOTTOMLEFT", AlwaysUpFrame2:GetRight() + 38, AlwaysUpFrame2:GetTop())
			hf:SetAlpha(1)
			hf:SetAttribute("macrotext", format("/target %s", hcarrier or ""))
			hf:SetPoint("LEFT", UIParent, "BOTTOMLEFT", AlwaysUpFrame3:GetRight() + 38, AlwaysUpFrame3:GetTop())
		end
		local function SetCarrier(faction, carrier, class)  -- setup carrier frames
			if not faction or faction == 0 then
				hcarrier, hclass, hf.car = carrier, class, carrier
				hftext:SetFormattedText("|cff%s%s|r", self:GetClassColorHex(class), carrier or "")
				hhealth = 0
				hftexthp:SetText((carrier and unknownhp) or "")
				hf:SetAlpha(0.6)
			end
			if not faction or faction == 1 then
				acarrier, aclass, af.car = carrier, class, carrier
				aftext:SetFormattedText("|cff%s%s|r", self:GetClassColorHex(class), carrier or "")
				ahealth = 0
				aftexthp:SetText((carrier and unknownhp) or "")
				af:SetAlpha(0.6)
			end
			Capping:CheckCombat(SetWSGCarrierAttribute)
		end
		local function UpdateHealth(faction, u, synchp)  -- Carrier's health text formatting
			if faction == "Alliance" then
				if not acarrier then return end
				local ahealth_before = ahealth
				ahealth = synchp or min(floor(100 * UnitHealth(u)/UnitHealthMax(u)), 100)
				aftexthp:SetFormattedText("|cff%s%d%%|r", (ahealth < ahealth_before and "ff2222") or "dddddd", ahealth)
				return ahealth
			else
				if not hcarrier then return end
				local hhealth_before = hhealth
				hhealth = synchp or min(floor(100 * UnitHealth(u)/UnitHealthMax(u)), 100)
				hftexthp:SetFormattedText("|cff%s%d%%|r", (hhealth < hhealth_before and "ff2222") or "dddddd", hhealth)
				return hhealth
			end
		end
		local function ScanRaid(friendcarrier, enemycarrier, enemyfaction, enemytext)  -- function to get carriers' health
			local efound, ffound
			for i = 1, GetNumRaidMembers(), 1 do
				-- scan each raid member's target to check for enemy carrier's health
				if enemycarrier and not efound then
					local t = "raid"..i.."target"
					if UnitIsEnemy(t, "player") and UnitName(t) == enemycarrier then
						local hp = UpdateHealth(enemyfaction, t, nil)
						found, efound = 0, true
						if synctime + 1.5 < GetTime() then
							SendAddonMessage("cap", hp, "BATTLEGROUND")
							synctime = GetTime()
						end
					end
				end
				-- scan own raid to get own carrier's health
				if friendcarrier and not ffound and UnitName("raid"..i) == friendcarrier then
					UpdateHealth(playerfaction, "raid"..i, nil)
					ffound = true
				end
			end

			-- enemy's carrier health is ?? after 6 seconds of being unknown
			found = found + 1
			if enemycarrier and found > 6 then
				enemytext:SetText(unknownhp)
			end
		end
		local function CarrierOnClick(this)  -- sends basic carrier info to battleground chat
			if IsControlKeyDown() then
				local carrier, class = acarrier, aclass
				if this.faction == "Horde" then
					carrier, class = hcarrier, hclass
				end
				if carrier then
					SendChatMessage(format(L["%s's flag carrier: %s (%s)"], this.faction, carrier, class), "BATTLEGROUND")
				end
			end
		end
		local function CreateWSGFrame()  -- create all frames
			local function CreateCarrierFrame(faction)  -- create carriers' frames
				local b = self:CreateCarrierButton("CappingTarget"..faction, 132, 18, CarrierOnClick)
				local text = self:CreateText(b, 14, "LEFT", b, 29, 0, b, 0, 0)
				local texthp = self:CreateText(b, 10, "RIGHT", b, -4, 0, b, 28 - b:GetWidth(), 0)
				b.faction = (faction == "Alliance" and _G.FACTION_ALLIANCE) or _G.FACTION_HORDE
				b.text = text
				self:AddFrameToHide(b)
				return b, text, texthp
			end
			af, aftext, aftexthp = CreateCarrierFrame("Alliance")
			hf, hftext, hftexthp = CreateCarrierFrame("Horde")

			af:SetScript("OnUpdate", function(this, a1)
				elap = elap + a1
				if (acarrier or hcarrier) and (elap > 1) then  -- health check and display
					elap = 0
					if playerfaction == "Alliance" then
						ScanRaid(acarrier, hcarrier, "Horde", hftexthp)
					else
						ScanRaid(hcarrier, acarrier, "Alliance", aftexthp)
					end
				end
			end)
			CreateCarrierFrame, CreateWSGFrame = nil, nil
		end
		local abuff, hbuff = GetSpellInfo(23335), GetSpellInfo(23333)
		self.WSGBulk = function()  -- stuff to do at the beginning of every wsg, but after combat
			af:Show()
			hf:Show()
			SetCarrier()

			self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_HORDE", "WSGHorde")
			self:RegisterTempEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE", "WSGAlliance")
			self:RegisterTempEvent("CHAT_MSG_ADDON", "WSGSync")
			self:RegisterTempEvent("UPDATE_WORLD_STATES", "WSGEnd")
			prevtime = nil
			self:WSGEnd()
			
			for i = 1, GetNumRaidMembers(), 1 do  -- check own team carrier on start
				for j = 1, UnitExists("raid"..i) and 32 or 0, 1 do
					local bname = UnitBuff("raid"..i, j)
					if not bname then break end
					if bname == abuff or bname == hbuff then
						SetCarrier((playerfaction == "Alliance" and 1) or 0, UnitName("raid"..i), select(2, UnitClass("raid"..i)))
						break
					end
				end
			end
			SendAddonMessage("cap", "rcar", "BATTLEGROUND")  -- request enemy carrier
		end
		--------------------------------
		function Capping:WSGAlliance(a1)
		--------------------------------
			self:WSGFlagCarrier(a1, 1)
		end
		-----------------------------
		function Capping:WSGHorde(a1)
		-----------------------------
			self:WSGFlagCarrier(a1, 0)
		end
		--------------------------------------------
		function Capping:WSGFlagCarrier(a1, faction)  -- carrier detection and setup
		--------------------------------------------
			local name = strmatch(a1, L["was picked up by (.+)!"]) or strmatch(a1, L["was picked up by (.+)!2"])
			if name then  -- flag was picked up
				SetCarrier(faction, name, self:GetClassByName(name, faction))
			elseif strmatch(a1, L["dropped"]) then  -- flag was dropped, reset for that carrier
				SetCarrier(faction == 0 and 1 or 0)
			elseif strmatch(a1, L["captured the"]) then  -- flag was captured, reset all carriers
				SetCarrier()
				self:StartBar(L["Flag respawns"], 23, 23, self:GetIconData(wsgicon, "flag"), "info2")
			end
		end
		-------------------------
		function Capping:WSGEnd()  -- timer for last 3 minutes of WSG
		-------------------------
			local _, _, timeremain = GetWorldStateUIInfo(1)
			timeremain = tonumber(strmatch(timeremain or "blah", "(%d+)") or 20) or 20
			if timeremain < 4 and prevtime and prevtime ~= timeremain then
				self:StartBar(gsub(_G.TIME_REMAINING or "Battle Ends", ":", ""), 3 * 61.5, timeremain * 61.5, "Interface\\Icons\\INV_Misc_Rune_07", "info2")
			end
			prevtime = timeremain
		end
		-------------------------------------------------------
		function Capping:WSGSync(prefix, message, chan, sender)
		-------------------------------------------------------
			if prefix ~= "cap" or sender == pname then return end
			local synchp = tonumber(message)
			if synchp then
				synctime = GetTime()
				found = 0
				UpdateHealth((playerfaction == "Alliance" and "Horde") or "Alliance", nil, synchp)
			elseif message then
				if message == "rcar" then
					if playerfaction == "Alliance" and hcarrier then
						SendAddonMessage("cap", hcarrier, "WHISPER", sender)
					elseif playerfaction == "Horde" and acarrier then
						SendAddonMessage("cap", acarrier, "WHISPER", sender)
					end
				elseif playerfaction == "Alliance" and not hcarrier then
					SetCarrier(0, message, self:GetClassByName(message, 0))
				elseif playerfaction == "Horde" and not acarrier then
					SetCarrier(1, message, self:GetClassByName(message, 1))
				end
			end
		end
	
		playerfaction = UnitFactionGroup("player")
		wsgicon = strlower(playerfaction)
		self:CheckCombat(CreateWSGFrame)
	end

	self:CheckCombat(self.WSGBulk)
end
